/**
 * Program POSIXové Fronty
 * @autor František Kučera <franta-hg@frantovo.cz>
 */

#include <program.h>
#include <stdlib.h>
#include <iostream>
#include <readline/readline.h>
#include <signal.h>
#include <strings.h>

#include "fronta.h"

using namespace std;

/**
 * Spuštění programu „POSIXovéFronty“
 */
int main() {

    cout << "Vítejte v programu POSIXovéFronty" << endl;

    /** Nastavíme reakci na signál SIGTERM */
    signal(SIGTERM, zpracujSignal);
    signal(SIGINT, zpracujSignal);

    /** TODO: zeptat se na název fronty – readline */
    //strcpy(nazevFronty, VYCHOZI_NAZEV_FRONTY);
    nazevFronty = "/mojeFronta";

    /** Program pracuje buď v režimu přijímání nebo odesílání */
    if (isOdesilaciRezim()) {
        odesilej();
    } else {
        prijimej();
    }

    /** Sem se nedostaneme, pokud metody poběží v cyklu – program končí, až když dostane patřičný signál. */
    fronta.zavriFrontu(false);
    return (EXIT_SUCCESS);
}

bool isOdesilaciRezim() {

    cout << "Zvolte režim: (p)řijímací / (o)desílací" << endl;

    char odpoved = cin.get();
    cin.get();

    if (odpoved == 'o') {
        return true;
    } else if (odpoved == 'p') {
        return false;
    } else {
        return isOdesilaciRezim();
    }
}

void odesilej() {
    cout << "Odesíláme…" << endl;
    fronta = Fronta(nazevFronty, false, true);

    while (true) {
        /** TODO: načítat pomocí readline */
        char zprava[100];
        cout << "Zadejte zprávu: \033[22;32m";
        cin.getline(zprava, 100);
        cout << "\033[0m\n";

        if (fronta.odesliZpravu(zprava) == 0) {
            cout << "Zpráva odeslána." << endl;
        } else {
            cout << "Při odesílání zprávy došlo k chybě." << endl;
        }
    }
}

void prijimej() {
    cout << "Přijímáme…" << endl;
    fronta = Fronta(nazevFronty, true, false);

    while (true) {
        char* zprava = fronta.prijmiZpravu();

        if (zprava == NULL) {
            cout << "Nepodařilo se přijmout zprávu." << endl;
        } else {
            printf("Přijatá zpráva: \033[22;32m%s\033[0m\n", zprava); // zelená
        }
    }
}

void zpracujSignal(int signal) {
    if (signal == SIGTERM || signal == SIGINT) {
        fronta.zavriFrontu(false);
        cout << endl << "\033[22;31m" << "Končím program na základě signálu " << signal << "." << "\033[0m" << endl; // červená
        exit(1);
    }
}

